; asapXCmd v2.0
; Keith Batten kbatten@usa.net
; 12 October 1999
;
; Edited with Assembly Studio 86 v3.0
; Tab width set to 4


;          Name and Parameters | Completed | Description of Function
;-----------------------------------------------------------------------------------------------
;Invert								[X]	Inverted text color
;Str([real])						[X]	Returns string representation of the number
;Chr([integer])						[X]	Returns the character of the ascii ascue
;Asc([string],[offset])				[X]	Returns the ascii value of the character in a string
;logx([base],[real])				[X]	Returns the log of a number with a specific base
;EXISTS("var")						[X]	Returns 1 if var exists or 0 if not
;Peek([var],[offset])				[/]	Returns the char in var at offset
;Poke([var],[offset],[string])		[/]	Stores the first char of string into var at offset
;RunOff								[X]	Run indicator off
;RunOn								[X]	Run indicator on
;BitIY([IY Offset],[bit number])	[X]	Returns one or zero if the bit at IY Offset is on or off
;SetIY([IY Offset],[bit number])	[X]	Sets the bit at IY Offset
;ResIY([IY Offset],[bit number])	[X]	Resets the bit at IY Offset
;LnOff([x1],[y1],[x2],[y2])			[X] Draws a white line from (x1,y1) to (x2,y2)

#include "asm86.h"
#include "rom86.h"
#include "ram86.h"


tokspell_start		.equ	$f3f8

TOKENS				.equ	14

.org _asm_exec_ram

Start:
; Check to see if xNoSetup exists
	ld hl, xNoSetup-1
	rst 20h					; put 'xNoSetup' into OP1
	rst 10h					; find the variable 'xNoSetup'
	jr nc, Install			; if it does exist, skip the setup and go straight to Install
							; if it doesn't exist, run the setup
Setup:
	call _clrLCD			; reset the text screen
	call _homeup
	call _flushallmenus
	ld hl, cautionMsg		; display caution message
	call Disp_Message

	call continue_Loop
	cp kF5
	jp z, _newline			; display a new line and quit if F5 was hit

 	ld a,(_numtok_asap3)	; make sure that nothing is installed in asap3
	or a
	jr z, Display_Credits	; Install but still display the credits

	call _clrLCD			; reset the text screen
	call _homeup
	call _flushallmenus
	ld hl, warningMsg		; display Warning: Tokens already exist message
	call Disp_Message

	call continue_Loop
	cp kF5
	jp z, _newline			; display a new line and quit if F5 was hit

Display_Credits:
	call _clrLCD			; reset the text screen
	call _clrScrn
	call _homeup
	call _flushallmenus
	ld hl, creditsMsg		; display credits
	call _puts
	call _newline
	call _newline

Install:
	ld a, TOKENS			; tell the calculator how many tokens are installed
	ld (_numtok_asap3), a

	ld de, tokspell_start	; ???
	ld (_tokspell_asap3), de
	ld hl, tokspell			; copy the tokens to ram
	ld bc, tokspell_end-tokspell
	ldir

	ld de, eostbl_start
	ld (_eostbl_asap3), de
	ld hl, eostbl			; copy the token table to ram
	ld bc, eostbl_end-eostbl
	ldir

	ld de, _asap_nl3		; copy this programs name into ram
	ld hl, asapName
	call _mov10b

	ld de, custom_start
	ld (_CustMSav+8),de		; set the 5th custom spot and
	ld (_mMath_asap3),de	; the 5th math spot to point to our menu
	ld hl, Custom			; copy our custom menu
	ld bc, custom_end-Custom
	ldir
	ret						; end installation

Disp_Message:
	ld a, (hl)				; loop through all the characters of the message
	inc hl
	cp 0					; if the character is 0 then we are done
	jr z, Disp_Message_Done
	cp 1					; if the character is 1 then it means its the end of a line
	call z, _newline
	jp z, Disp_Message
	cp 2					; if the character is not 2 then display it
	call nz, _putc
	jr nz, Disp_Message
	push hl
	ld hl, _asap_nl3		; if the character is two, replace it with the currently installed asap3 program
	call _putps
	pop hl
	jr Disp_Message
Disp_Message_Done:
	ld hl, $0007			; we are done so display the little choice at the bottom of the screen
	ld (_curRow), hl	
	ld hl, continueExitMsg
	jp _puts				; put the message and return

continue_Loop:
	call _getkey
	or a					; compare a to 0
	jr z, continue_Loop
	cp kF5					; if it is F5 then quit
	ret
	cp kF1					; if it is F1 then continue
	jr nz, continue_Loop	; if not then retry the loop
	ret

xNoSetup:
.db 8,"xNoSetup"

cautionMsg:
.db "Caution",1
.db "Any item in the 5th",1
.db "CUSTOM menu slot or",1
.db "the 9th MATH menu",1
.db "slot will be",1
.db "overwritten.",0

warningMsg:
.db "WARNING",1
.db "Tokens already exist",1
.db "from prgm ",2,1
.db "Installation WILL",1
.db "erase the previously",1
.db "installed tokens.",0

continueExitMsg:
.db "Continue        Exit",0

creditsMsg:
.db "asapXCmd v2.0        ",0
.db "by Keith Batten",0

asapName:
.db 8,"asapXCmd",0


tokspell:
.dw tok_asc-tokspell+tokspell_start
.dw tok_bitiy-tokspell+tokspell_start
.dw tok_chr-tokspell+tokspell_start
.dw tok_exists-tokspell+tokspell_start
.dw tok_invert-tokspell+tokspell_start
.dw tok_lnoff-tokspell+tokspell_start
.dw tok_logx-tokspell+tokspell_start
.dw tok_peek-tokspell+tokspell_start
.dw tok_poke-tokspell+tokspell_start
.dw tok_resiy-tokspell+tokspell_start
.dw tok_runoff-tokspell+tokspell_start
.dw tok_runon-tokspell+tokspell_start
.dw tok_setiy-tokspell+tokspell_start
.dw tok_str-tokspell+tokspell_start
tok_asc:
.db "Asc",0
.db $01,$00
tok_bitiy:
.db "BitIY",0
.db $02,$00
tok_chr:
.db "Chr",0
.db $03,00
tok_exists:
.db "EXISTS",0
.db $04,$00
tok_invert:
.db "Invert",0
.db $05,$00
tok_lnoff:
.db "LnOff",0
.db $06,$00
tok_logx:
.db "logx",0
.db $07,$00
tok_peek:
.db "Peek",0
.db $08,$00
tok_poke:
.db "Poke",0
.db $09,$00
tok_resiy:
.db "ResIY",0
.db $0A,$00
tok_runoff:
.db "RunOff",0
.db $0B,$00
tok_runon:
.db "RunOn",0
.db $0C,$00
tok_setiy:
.db "SetIY",0
.db $0D,$00
tok_str:
.db "Str",0
.db $0E,$00
tokspell_end:

eostbl:
.dw Code_Asc
.db $04,$00
.dw Code_Bitiy
.db $04,$00
.dw Code_Chr
.db $02,$00
.dw Code_Exists
.db $04,$00
.dw Code_Invert
.db $01,$00
.dw Code_Lnoff
.db $04,$00
.dw Code_Logx
.db $04,$00
.dw Code_Peek
.db $04,$00
.dw Code_Poke
.db $04,$00
.dw Code_Resiy
.db $04,$00
.dw Code_Runoff
.db $01,$00
.dw Code_Runon
.db $01,$00
.dw Code_Setiy
.db $04,$00
.dw Code_Str
.db $02,$00
eostbl_end:

Custom:
.db $05								;open a menu
.dw Custom_Sub-Custom+custom_start	;at custom_sub
.db "XCmd",0						;called XCmd

Custom_Sub:
.db $08,5
.dw Menu_Text-Custom+custom_start
.dw Menu_Math-Custom+custom_start
.dw Menu_Var-Custom+custom_start
.dw Menu_Misc-Custom+custom_start
.dw Menu_Grfx-Custom+custom_start

Menu_Text:
.db $05									;open a menu
.dw Custom_Text-Custom+custom_start		;at custom_text
.db "Text",0
Menu_Math:
.db $05									;open a menu
.dw Custom_Math-Custom+custom_start		;at custom_math
.db "Math",0
Menu_Var:
.db $05									;open a menu
.dw Custom_Misc-Custom+custom_start		;at custom_misc
.db "Misc",0
Menu_Misc:
.db $05									;open a menu
.dw Custom_Var-Custom+custom_start		;at custom_var
.db "Var",0
Menu_Grfx:
.db $05									;open a menu
.dw Custom_Grfx-Custom+custom_start		;at custom_grfx
.db "Grfx",0

Custom_Text:
.db $08,4							;new menu w/ 4 positions
.dw Menu_Invert-Custom+custom_start
.dw Menu_Str-Custom+custom_start
.dw Menu_Chr-Custom+custom_start
.dw Menu_Asc-Custom+custom_start

Custom_Math:
.db $08,1							;new menu w/ 1 position
.dw Menu_Logx-Custom+custom_start

Custom_Var:
.db $08,3							;new menu w/ 3 positions
.dw Menu_Exists-Custom+custom_start
.dw Menu_Peek-Custom+custom_start
.dw Menu_Poke-Custom+custom_start

Custom_Misc:
.db $08,5							;new menu w/ 5 positions
.dw Menu_Runon-Custom+custom_start
.dw Menu_Runoff-Custom+custom_start
.dw Menu_Bitiy-Custom+custom_start
.dw Menu_Setiy-Custom+custom_start
.dw Menu_Resiy-Custom+custom_start

Custom_Grfx:
.db $08,1							;new menu w/ 1 position
.dw Menu_Lnoff-Custom+custom_start

Menu_Invert:
.db $00,"Invert",0
Menu_Str:
.db $60,"Str",0
Menu_Chr:
.db $60,"Chr",0
Menu_Asc:
.db $60,"Asc",0
Menu_Logx:
.db $60,"logx",0
Menu_Runoff:
.db $00,"RunOff",0
Menu_Runon:
.db $00,"RunOn",0
Menu_Exists:
.db $60,"EXISTS",0
Menu_Peek:
.db $60,"Peek",0
Menu_Poke:
.db $60,"Poke",0
Menu_Bitiy:
.db $60,"BitIY",0
Menu_Setiy:
.db $60,"SetIY",0
Menu_Resiy:
.db $60,"ResIY",0
Menu_Lnoff:
.db $60,"LnOff",0
custom_end:

Code_Asc:
	ld a, ($CE21)			; check number of arguments
	cp 2
	call nz, _errArgument
	ld a, $00				; check for real
	call Check_Type
	call _convop1			; convert OP1 to de
	ld (offset), de			; save that offset
	call Pop_Op1			; get next paramater
	ld a, $0C				; check for string
	call Check_Type
	call Get_Byte			; get a byte at offset
	ld l, a
	ld h, 0
	call _setXXXXop2		; change hl into a real at OP2
	call _op2toop1
	jp _stoAns				; return it in ans

Code_Bitiy:
	ld a, ($CE21)			; check number of arguments
	cp 2
	call nz, _errArgument
	call Get_IY
	ld a, (bitNum)
	and (hl)				; check the bit
	cp 0
	push af
	call _op1set1			; preset op1 to 1
	pop af
	call z, _op1set0		; it wasn't set so we reset op1 to 0
	jp _stoAns				; return a 1 if set or 0 if not

Code_Chr:
	ld a, $00				; check for real
	call Check_Type
	call _convop1			; convert OP1 to a
	ld (byte), a			; save a
	ld hl, 1
	call _createstrng_temp
	ld a, (byte)			; restore a
	ld c, a
	call _ex_ahl_bde		; swap ahl and bde
	call _ahl_plus_2_pg3	; add 2 to ahl to point it to program data
	call _writeb_inc_ahl	; write c to ahl
	jp _op4toop1

Code_Exists:
	ld a, ($CE21)			; check for one parameter
	cp 1
	call nz, _errArgument
	ld a, $0C
	call Check_Type
	rst 10h					; find the variable
	ld a, b
	ex de, hl
	call _set_abs_src_addr	; copy 10 bytes from string to name-2
	xor a
	ld hl, 10
	call _set_mm_num_bytes
	xor a
	ld hl, name-2
	call _set_abs_dest_addr
	call _mm_ldir
	ld a, (name-2)			; we only neen a max length of 8 so we can move
	ld (name-1), a			; this up so the length will precede the name
	ld hl, name-2
	rst 20h
	rst 10h					; find variable
	push af
	call _op1set1			; variable exists
	pop af
	call c, _op1set0		; variable does not exist
	jp _stoAns

Code_Invert:
	ld a,%00001000			; flip bit number 3 on text flags
	xor (iy+textflags)
	ld (iy+textflags),a
	ret

Code_Lnoff:
	ld a, ($CE21)			; check number of arguments
	cp 4
	call nz, _errArgument
	ld a, $00				; check for real
	call Check_Type
	call _convop1			; convert OP1 to a
	ld (y2), a				; save y2
	call Pop_Op1			; get next parameter
	ld a, 0					; check for a real
	call Check_Type
	call _convop1			; convert OP1 to a
	ld (x2), a				; save x2
	call Pop_Op1			; get next parameter
	ld a, 0					; check for a real
	call Check_Type
	call _convop1			; convert OP1 to a
	ld (y1), a				; save y1
	call Pop_Op1			; get next parameter
	ld a, 0					; check for a real
	call Check_Type
	call _convop1			; convert OP1 to a
	ld (x1), a				; save x1
	call _PDspGrph			; make sure we draw to the graph screen just like the Line( command
	ld a, (x1)				; restore the coords
	cp 127
	jp nc, _errDomain
	ld b, a
	ld a, (y1)
	cp 63
	jp nc, _errDomain
	xor 63
	ld c, a
	ld a, (x2)
	cp 127
	jp nc, _errDomain
	ld d, a
	ld a, (y2)
	cp 63
	jp nc, _errDomain
	xor 63
	ld e, a
	ld h, 0
	call _ILine				; draw the line
	jp _op1set0

Code_Logx:
	ld a, ($CE21)			; check number of arguments
	cp 2
	call nz, _errArgument
	ld a, 0					; check for a real
	call Check_Type
	call _LOGX				; generate error if negative
	call _op1toop6			; OP6 = log OP1
	call Pop_Op1			; get next parameter
	ld a, 0					; check for a real
	call Check_Type
	call _LOGX				; generate error if negative
	call _op1toop2			; OP2 = log OP1
	call _op6toop1
	call _FPDIV				; OP1 = (log param1) / (log param2)
	jp _stoAns				; return it in ans

Code_Peek:
	ld a, ($CE21)			; check number of arguments
	cp 2
	call nz, _errArgument
	ld a, 0					; check for a real
	call Check_Type
	call _convop1			; convert OP1 to de
	ld (offset), de			; save the offset
	call Pop_Op1			; get next parameter
	call Get_Byte			; get a byte at offset
	ld (byte), a 			; save it
	ld hl, 1
	call _createstrng_temp
	ld a, (byte)			; restor byte
	ld c, a
	ld a, b					; convert bde to ahl
	ex de, hl
	call _ahl_plus_2_pg3	; add 2 to ahl to point it to program data
	call _writeb_inc_ahl	; write that byte to ans
	jp _op4toop1

Code_Poke:
	ld a, ($CE21)			; check number of arguments
	cp 3
	call nz, _errArgument
	ld a, $0C				; check for string
	call Check_Type
	ld a, 1
	ld (offset), a			; get the first byte of string
	call Get_Byte
	ld (byte), a			; save it in byte 
	call Pop_Op1			; get the next parameter
	ld a, $00				; check for real
	call Check_Type
	call _convop1			; convert OP1 to de
	ld (offset), de			; save it in offset
	call Pop_Op1			; get the next parameter
	call Write_Byte			; write it to the variable
	call _op1set1
	jp _stoAns				; store it to Ans and quit

Code_Resiy:
	ld a, ($CE21)			; check number of arguments
	cp 2
	call nz, _errArgument
	call Get_IY				; get the offset and bit number
	ld a, (bitNum)
	and (hl)
	xor (hl)
	ld (hl), a				; zero the bit
	ret

Code_Runoff:
	jp _runindicoff			; turn the run indicator off

Code_Runon:
	jp _runindicon			; turn the run indicator on

Code_Setiy:
	ld a, ($CE21)			; check number of arguments
	cp 2
	call nz, _errArgument
	call Get_IY				; get the offset and bit number
	ld a, (bitNum)
	or (hl)
	ld (hl), a				; set the bit
	ret

Code_Str:
	ld a, $00				; check for a real
	call Check_Type
	ld a, $12				; set the precision to 16
	call _formReal			; convert OP1 to a string
	ld de, tempReal			; save _OP3 into temp_real
	ld hl, _OP3
	ld bc, $12
	ldir
	ld b, 0
	ld hl, tempReal
	call Find_Len			; get the length of temp_real
	ld h, 0
	ld l, b
	push hl
	call _createstrng_temp
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_dest_addr
	xor a
	pop hl
	call _set_mm_num_bytes
	ld hl, tempReal
	call _set_abs_src_addr
	call _mm_ldir			; copy temp_real to the string
	jp _op4toop1

Check_Type:
	ld b, a
	ld a, (_OP1)			; load the variable type into a
	and %00001111			; mask out the top 4 bits
	cp b					; make sure it is the right type
	jp nz, _errDataType
	ret

Find_Len:
	ld a, (hl)
	or a
	ret z
	inc b
	inc hl
	jr Find_Len

Get_Byte:
	rst 10h					; find variable
	ld a,b
	ex de,hl
	ld de, (offset)
	inc de
	call Inc_Ahl_De			; add offset to ahl
	jp _getb_ahl			; read the byte

Get_IY:
	ld a, $00				; check for a real
	call Check_Type
	call _convop1			; change OP1 into a
	ld (bitNum), a
	call Pop_Op1			; get next parameter
	ld a, $00				; check for real
	call Check_Type
	call _convop1			; change OP1 into a
	ld (offset), a
	ld a, 17
	ld (_ERRNO), a			; set error number to 17: Invalid
	ld a, (bitNum)
	call Int_To_Bit			; change the integer in a to a bit value in b
	ld a, b
	cp 3					; make sure they put a valid bit number
	jp z, _error			; nope so invoke the error
	ld (bitNum),a			; reload the bit value
	ld a, (offset)
	ld d, 0
	ld e, a
	push iy					; load iy into hl
	pop hl
	add hl, de				; add to find (iy+offset)
	ret

Inc_Ahl_De:
	ld c, a
incahlde_loop:
	ld a, c
	call _inc_ptr_ahl
	ld c, a
	dec de
	ld b, a
	ld a, e
	cp 0
	ld a, b
	jr nz, Inc_Ahl_De
	ld a, d
	cp 0
	ld a, b
	ld a, c
	ret z
	jr Inc_Ahl_De

Int_To_Bit:
	ld b, 1			; 1(->)B
Int_To_Bit_Loop:
	cp 0			; if a==0
	ret z			; end
	dec a			; a-1(->)a
	sla b			; shftL B(->)B
	jr Int_To_Bit_Loop	; goto Int_To_Bit_Loop	

;	ld b, %00000000
;	cp 0
;	ret z
;	ld b, %00000010
;	cp 1
;	ret z
;	ld b, %00000100
;	cp 2
;	ret z
;	ld b, %00001000
;	cp 3
;	ret z
;	ld b, %00010000
;	cp 4
;	ret z
;	ld b, %00100000
;	cp 5
;	ret z
;	ld b, %01000000
;	cp 6
;	ret z
;	ld b, %10000000
;	cp 7
;	ret z
;	ld b, %00000011
;	ret

Pop_Op1:
	call _sub_FPS_10		; decrease the FPS by ten
	call _load_ram_FPS		; make ahl a valid ASIC pointer
	ld de, _OP1				; copy it into hl
	ld bc, 10
	ldir
	ret

Write_Byte:
	rst 10h					; find variable
	ld a,b
	ex de,hl
	ld de, (offset)
	inc de
	call Inc_Ahl_De			; add de to ahl
	push af					; save a
	ld a, (byte)
	ld c, a
	pop af					; restore a 
	jp _writeb_inc_ahl		; write c to ahl

ansOp:
.db $0C
.db $03,"Ans",0

tempReal:
x1:
.db 0
y1:
.db 0
name:
x2:
.db 0
y2:
.db 0
.db 0,0,0,0,0,0,0,0,0,0,0
offset:
.db 0,0
byte:
bitNum:
.db 0

eostbl_start		.equ	tokspell_start+tokspell_end-tokspell
custom_start		.equ	tokspell_start+eostbl_end-tokspell

.end
